﻿Public Class Form1
    Dim Cls_NWP As New NSDWebPicture(Me)

    #Region "Class NSDCmbItemColor : 色用のコンボボックスデータ."
        Public Class NSDCmbItemColor
            Private Str_Name As String = Nothing ' 名前.
            Private Cls_Color As System.Drawing.Color = Nothing

            #Region "Sub New : リソースの割り当て."
                Public Sub New(ByVal C As System.Drawing.Color)
                    Cls_Color = C
                    Str_Name = Cls_Color.Name.ToString
                End Sub
            #End Region

            #Region "Property Name : 色の名前."
                Public ReadOnly Property Name() As String
                    Get
                        Return Str_Name
                    End Get
                End Property
            #End Region

            #Region "Property Color : 色."
                Public ReadOnly Property Color() As System.Drawing.Color
                    Get
                        Return Cls_Color
                    End Get
                End Property
            #End Region
            
            #Region "Function ToString : 色の名前."
                Public Overrides Function ToString() As String
                    Return Str_Name
                End Function
            #End Region
        End Class
    #End Region

    #Region "Sub Form1_Load : Loadイベント."
        Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Try
                ' BMPをセット.
                Me.Cmb_PX.SelectedIndex = NSDWebPicture.NSDPictureExtension.Bmp

                ' 文字サイズをセット.
                Me.Cmb_StringSize.SelectedIndex = Cls_NWP.StringSize

                ' 作成サイズ.
                Me.Cmb_Size.SelectedIndex = 0   ' 自動.

                ' サイズのスタイル.
                Me.Cmb_Size2_Style.SelectedIndex = 0    ' 自動調整.

                ' 余白の色.
                With Me.Cmb_Size2_Blank_Color
                    For Int_Loop As Integer = 0 To 7
                        Dim Cls_Color As System.Drawing.Color
                        Select Case Int_Loop
                            Case 0: Cls_Color = Color.Black
                            Case 1: Cls_Color = Color.Blue
                            Case 2: Cls_Color = Color.Red
                            Case 3: Cls_Color = Color.Magenta
                            Case 4: Cls_Color = Color.Green
                            Case 5: Cls_Color = Color.Cyan
                            Case 6: Cls_Color = Color.Yellow
                            Case 7: Cls_Color = Color.White
                        End Select
                        Dim OneData As New NSDCmbItemColor(Cls_Color)
                        .Items.Add(OneData)
                    Next
                    .SelectedIndex = 0
                End With

                With Cls_NWP
                    ' 幅.
                    .SelectSizeWidth = 640

                    ' 高さ.
                    .SelectSizeHeight = 480
                End With

            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_FormClosing : FormClosing."
        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                ' NSDWebPictureを解放します.
                If Not (Cls_NWP Is Nothing) Then
                    Cls_NWP.Dispose()
                    Cls_NWP = Nothing
                End If
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub GetPic_Click : 画像ファイルに変換."
        Private Sub GetPic_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_GetPic.Click
            Try
                Do
                    Dim Str_Url As String = Me.Txt_Url.Text
                    If String.IsNullOrEmpty(Str_Url) Then
                        MsgBox("URLを入力してください。")
                        Exit Do
                    End If

                    Dim Str_File As String = Me.Txt_File.Text
                    If String.IsNullOrEmpty(Str_File) Then
                        MsgBox("保存するファイルをフルパス名で入力してください。")
                        Exit Do
                    End If

                    With Cls_NWP
                        ' 文字のサイズを設定.
                        .StringSize = Me.Cmb_StringSize.SelectedIndex

                        ' 倍率を設定.
                        .Zoom = Me.NUD_Rate.Value

                        ' JPEG品質を設定.
                        .JpegQuality = Me.NUD_Quality.Value

                        ' 最小の幅を設定.
                        .MinimumWidth = Me.NUD_Minimum_Width.Value

                        ' 最小の高さを設定.
                        .MinimumHeight = Me.NUD_Minimum_Height.Value

                        ' サイズ設定.
                        .Thumbnail = False
                        .SelectSize = False

                        Select Case Me.Cmb_Size.SelectedIndex
                            Case 0
                                ' 自動.
                            Case 1
                                ' サムネイル.
                                .Thumbnail = True

                                ' サムネイルサイズ(幅).
                                .ThumbnailWidth = Me.NUD_Size_Width.Value

                                ' サムネイルサイズ(高さ).
                                .ThumbnailHeight = Me.NUD_Size_Height.Value
                            Case 2
                                ' 指定サイズ.

                                .SelectSize = True

                                ' 幅.
                                .SelectSizeWidth = Me.NUD_Size_Width.Value

                                ' 高さ.
                                .SelectSizeHeight = Me.NUD_Size_Height.Value

                                ' スタイル.
                                .SelectSizeStyle = Me.Cmb_Size2_Style.SelectedIndex

                                ' 余白の色を指定する.
                                .SelectSizeSetBlankColor = Me.Chk_Size_BlankColor.Checked

                                ' 余白の色.
                                .SelectSizeBlankColor = Me.Cmb_Size2_Blank_Color.SelectedItem.Color
                        End Select

                        ' 余白を自動削除する.
                        .BlankCut = Me.Chk_Blank.Checked

                        ' 余白の左マージン.
                        .BlankMarginLeft = Me.NUD_Blank_Left.Value

                        ' 余白の下マージン.
                        .BlankMarginBottom = Me.NUD_Blank_Bottom.Value

                        ' ファイルを作成.
                        If .SaveImage(Str_Url, Str_File, Me.Cmb_PX.SelectedIndex) Then
                            MsgBox("ファイルを作成しました。")
                        Else
                            MsgBox("ファイルの作成に失敗しました。")
                        End If
                    End With
                Loop While (0)
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_PX_SelectedIndexChanged : 画像ファイルの種類を選択."
        Private Sub Cmb_PX_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Cmb_PX.SelectedIndexChanged
            Try
                ' JPEGのみEnabledをTrueにします.
                Me.Pn_Quality.Enabled = (CType(sender, ComboBox).SelectedIndex = 0)
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Chk_Thumbnail_CheckedChanged : サムネイル用サイズで作成."
        Private Sub Chk_Thumbnail_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) 
            Try
                Dim Bln_Enabeld As Boolean = CType(sender, CheckBox).Checked

                Me.Lbl_Size_Width.Enabled = Bln_Enabeld
                Me.Lbl_Size_Height.Enabled = Bln_Enabeld
                Me.NUD_Size_Width.Enabled = Bln_Enabeld
                Me.NUD_Size_Height.Enabled = Bln_Enabeld
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Chk_Blank_CheckedChanged : 余白を自動削除する."
        Private Sub Chk_Blank_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_Blank.CheckedChanged
            Try
                Dim Bln_Enabeld As Boolean = CType(sender, CheckBox).Checked

                Me.Lbl_Blank_Left.Enabled = Bln_Enabeld
                Me.Lbl_Blank_Bottom.Enabled = Bln_Enabeld
                Me.NUD_Blank_Left.Enabled = Bln_Enabeld
                Me.NUD_Blank_Bottom.Enabled = Bln_Enabeld
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Cmb_Size_SelectedIndexChanged : 作成サイズの選択."
        Private Sub Cmb_Size_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Cmb_Size.SelectedIndexChanged
            Try
                Select Case CType(sender, ComboBox).SelectedIndex
                    Case 0
                        ' 自動.
                        Me.Pn_Size.Enabled = False
                    Case 1
                        ' サムネイル.
                        Me.Pn_Size.Enabled = True
                        Me.Pn_Size2.Enabled = False

                        With Me.NUD_Size_Width
                            .Value = Cls_NWP.ThumbnailWidth
                            .Maximum = 300
                            .Minimum = 100
                        End With
                        With Me.NUD_Size_Height
                            .Value = Cls_NWP.ThumbnailHeight
                            .Maximum = 300
                            .Minimum = 100
                        End With

                    Case 2
                        ' 指定サイズ.

                        Me.Pn_Size.Enabled = True
                        Me.Pn_Size2.Enabled = True

                        With Me.NUD_Size_Width
                            .Maximum = 5000
                            .Minimum = -1
                            .Value = Cls_NWP.SelectSizeWidth
                        End With
                        With Me.NUD_Size_Height
                            .Maximum = 5000
                            .Minimum = -1
                            .Value = Cls_NWP.SelectSizeHeight
                        End With

                End Select
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Chk_Size_BlankColor_CheckedChanged : 余白の色を指定する"
        Private Sub Chk_Size_BlankColor_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Chk_Size_BlankColor.CheckedChanged
            Try
                Me.Cmb_Size2_Blank_Color.Enabled = Me.Chk_Size_BlankColor.Checked
            Catch ex As Exception

            End Try
        End Sub
    #End Region
End Class
